'use strict'

/**
 * @description Remove array duplicates or customized with JS
 * @author zhouzhechao
 * @date  2019-10-21 
 */


/**
 * @param {Array<*>} arr  The target array
 * @param {<*>} item Removes item specified duplicate
 * @description Removes item duplicates from an array
 */
function removeDuplicates(arr, item) {
    if (!Array.isArray(arr)) {
        throw new Error('First argument to removeDuplicates must be an array.');
    }

    if (arr.length <= 1) {
        return
    }

    if(item && arr.indexOf(item) === -1) {
        return
    }

    let newA = []
    if (item) {
        newA = arr.filter((v, i) => (v !== 2) || (v === 2 && arr.indexOf(v) === i))
    } else {
        newA = arr.filter((v, i) => arr.indexOf(v) === i)
    }
    for(let i in newA) {
        arr[i] = newA[i]
    }
    arr.length = newA.length

    /** ============================================== */
    // let map = new Map()
    // for (let i of arr) {
    //     if (map.has(i)) {
    //         map.set(i, map.get(i) + 1)
    //     } else {
    //         map.set(i, 1)
    //     }
    // }

    // let count = 0
    // for (let i of map.keys()) {
    //     arr.fill(i, count, count += map.get(i))
    // }

    // let i = 0
    // for (let j = 1; j < arr.length; j++) {
    //     if (arr[j] !== arr[i]) {
    //         arr[++i] = arr[j]
    //     }
    // }
    // arr.length = ++i
    /** ============================================== */
    // let map = new Map()
    // for (let i of arr) {
    //     if (map.has(i)) {
    //         map.set(i, map.get(i) + 1)
    //     } else {
    //         map.set(i, 1)
    //     }
    // }
    // let j = 0, b = []
    // for(let i in arr) {
    //     let t = map.get(arr[i])
    //     map.set(arr[i], )
    //     for(; t>0; --t) {
    //         b[j++] = arr[i]
    //     }
    // }
    // for(let i in arr) {
    //     arr[i] = b[i]
    // }

    /** ============================================== */
    // if (arr.length < 20) { // just for sorted array
    //     let i = 0
    //     for (let j = 1; j < arr.length; j++) {
    //         if (arr[j] !== arr[i]) {
    //             arr[++i] = arr[j]
    //         }
    //     }
    //     arr.length = ++i
    // } else {
    //     arr = arr.filter((v, i) => arr.indexOf(v) === i)
    // }
}

/**
 * @param {Array<*>} arr The target array
 * @param {number} start The index to begin removing
 * @param {number} count The count of items need to remove
 * @description performs better to splice, use Proxy can watch splice and removeItems
 */
function removeItems(arr, start, count) {
    let len = arr.length

    // edge return
    if (start >= len || count <= 0 || Object.isFrozen(arr)) {
        return
    }

    // start <= -len  start = 0
    if (start + len <= 0) {
        start = 0
    } else if (start < 0) {
        start = start + len
    }

    let length = len - count
    if (start + count >= len) {
        arr.length = start
    } else {
        for (let i = start; i < length; ++i) {
            arr[i] = arr[i + count]
        }
        arr.length = length
    }
}

module.exports = {
    removeDuplicates,
    removeItems
}